scala.math

# ScalaNumericConversions

#### trait ScalaNumericConversions extends ScalaNumber with ScalaNumericAnyConversions

A slightly more specific conversion trait for classes which extend ScalaNumber (which excludes value classes.)

Source
  ScalaNumericConversions.scala

Linear Supertypes
ScalaNumericAnyConversions, ScalaNumber, Number, java.io.Serializable, AnyRef, Any
Known Subclasses
BigDecimal, BigInt
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. ScalaNumericConversions
2. ScalaNumericAnyConversions
3. ScalaNumber
4. Number
5. Serializable
6. AnyRef
7. Any

Implicitly

1. by any2stringadd
2. by any2stringfmt
3. by any2ArrowAssoc
4. by any2Ensuring

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract def doubleValue(): Double

   Definition Classes
     ScalaNumericAnyConversions

2. #### abstract def floatValue(): Float

   Definition Classes
     ScalaNumericAnyConversions

3. #### abstract def intValue(): Int

   Definition Classes
     ScalaNumericAnyConversions

4. #### abstract def isWhole(): Boolean

   Definition Classes
     ScalaNumericAnyConversions

5. #### abstract def longValue(): Long

   Definition Classes
     ScalaNumericAnyConversions

6. #### abstract def underlying(): AnyRef

   Definition Classes
     ScalaNumericConversions → ScalaNumericAnyConversions → ScalaNumber

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ScalaNumericConversions to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ->[B](y: B): (ScalaNumericConversions, B)

   Implicit information
     This member is added by an implicit conversion from ScalaNumericConversions to ArrowAssoc[ScalaNumericConversions] performed by method any2ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline ()

6. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

7. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

8. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown
     ClassCastException

     if the receiver object is not an instance of the erasure of type `T0`.

9. #### def byteValue(): Byte

   Definition Classes
     Number

10. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )
    Note

      not specified by SLS as a member of AnyRef

11. #### def ensuring(cond: (ScalaNumericConversions) ⇒ Boolean, msg: ⇒ Any): ScalaNumericConversions

    Implicit information
      This member is added by an implicit conversion from ScalaNumericConversions to Ensuring[ScalaNumericConversions] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: (ScalaNumericConversions) ⇒ Boolean): ScalaNumericConversions

    Implicit information
      This member is added by an implicit conversion from ScalaNumericConversions to Ensuring[ScalaNumericConversions] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: Boolean, msg: ⇒ Any): ScalaNumericConversions

    Implicit information
      This member is added by an implicit conversion from ScalaNumericConversions to Ensuring[ScalaNumericConversions] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: Boolean): ScalaNumericConversions

    Implicit information
      This member is added by an implicit conversion from ScalaNumericConversions to Ensuring[ScalaNumericConversions] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

16. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

17. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws ( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

18. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from ScalaNumericConversions to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline ()

19. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

20. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

21. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

22. #### def isValidByte: Boolean

    Returns `true` iff this has a zero fractional part, and is within the range of scala.Byte MinValue and MaxValue; otherwise returns `false`.

    Returns `true` iff this has a zero fractional part, and is within the range of scala.Byte MinValue and MaxValue; otherwise returns `false`.

    Definition Classes
      ScalaNumericAnyConversions

23. #### def isValidChar: Boolean

    Returns `true` iff this has a zero fractional part, and is within the range of scala.Char MinValue and MaxValue; otherwise returns `false`.

    Returns `true` iff this has a zero fractional part, and is within the range of scala.Char MinValue and MaxValue; otherwise returns `false`.

    Definition Classes
      ScalaNumericAnyConversions

24. #### def isValidInt: Boolean

    Returns `true` iff this has a zero fractional part, and is within the range of scala.Int MinValue and MaxValue; otherwise returns `false`.

    Returns `true` iff this has a zero fractional part, and is within the range of scala.Int MinValue and MaxValue; otherwise returns `false`.

    Definition Classes
      ScalaNumericAnyConversions

25. #### def isValidShort: Boolean

    Returns `true` iff this has a zero fractional part, and is within the range of scala.Short MinValue and MaxValue; otherwise returns `false`.

    Returns `true` iff this has a zero fractional part, and is within the range of scala.Short MinValue and MaxValue; otherwise returns `false`.

    Definition Classes
      ScalaNumericAnyConversions

26. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

27. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

28. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

29. #### def shortValue(): Short

    Definition Classes
      Number

30. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

31. #### def toByte: Byte

    Returns the value of this as a scala.Byte.

    Returns the value of this as a scala.Byte. This may involve rounding or truncation.

    Definition Classes
      ScalaNumericAnyConversions

32. #### def toChar: Char

    Returns the value of this as a scala.Char.

    Returns the value of this as a scala.Char. This may involve rounding or truncation.

    Definition Classes
      ScalaNumericAnyConversions

33. #### def toDouble: Double

    Returns the value of this as a scala.Double.

    Returns the value of this as a scala.Double. This may involve rounding or truncation.

    Definition Classes
      ScalaNumericAnyConversions

34. #### def toFloat: Float

    Returns the value of this as a scala.Float.

    Returns the value of this as a scala.Float. This may involve rounding or truncation.

    Definition Classes
      ScalaNumericAnyConversions

35. #### def toInt: Int

    Returns the value of this as an scala.Int.

    Returns the value of this as an scala.Int. This may involve rounding or truncation.

    Definition Classes
      ScalaNumericAnyConversions

36. #### def toLong: Long

    Returns the value of this as a scala.Long.

    Returns the value of this as a scala.Long. This may involve rounding or truncation.

    Definition Classes
      ScalaNumericAnyConversions

37. #### def toShort: Short

    Returns the value of this as a scala.Short.

    Returns the value of this as a scala.Short. This may involve rounding or truncation.

    Definition Classes
      ScalaNumericAnyConversions

38. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

39. #### def unifiedPrimitiveEquals(x: Any): Boolean

    Should only be called after all known non-primitive types have been excluded.

    Should only be called after all known non-primitive types have been excluded. This method won't dispatch anywhere else after checking against the primitives to avoid infinite recursion between equals and this on unknown "Number" variants.

    Additionally, this should only be called if the numeric type is happy to be converted to Long, Float, and Double. If for instance a BigInt much larger than the Long range is sent here, it will claim equality with whatever Long is left in its lower 64 bits. Or a BigDecimal with more precision than Double can hold: same thing. There's no way given the interface available here to prevent this error.

    Attributes
      protected
    Definition Classes
      ScalaNumericAnyConversions

40. #### def unifiedPrimitiveHashcode(): Int

    Attributes
      protected
    Definition Classes
      ScalaNumericAnyConversions

41. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )

42. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )

43. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )

44. #### def →[B](y: B): (ScalaNumericConversions, B)

    Implicit information
      This member is added by an implicit conversion from ScalaNumericConversions to ArrowAssoc[ScalaNumericConversions] performed by method any2ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Shadowed Implicit Value Members

1. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from ScalaNumericConversions to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (scalaNumericConversions: StringAdd).self

   Definition Classes
     StringAdd

2. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from ScalaNumericConversions to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (scalaNumericConversions: StringFormat).self

   Definition Classes
     StringFormat

### Deprecated Value Members

1. #### def x: ScalaNumericConversions

   Implicit information
     This member is added by an implicit conversion from ScalaNumericConversions to ArrowAssoc[ScalaNumericConversions] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (scalaNumericConversions: ArrowAssoc[ScalaNumericConversions]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

2. #### def x: ScalaNumericConversions

   Implicit information
     This member is added by an implicit conversion from ScalaNumericConversions to Ensuring[ScalaNumericConversions] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (scalaNumericConversions: Ensuring[ScalaNumericConversions]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from ScalaNumericAnyConversions

### Inherited from ScalaNumber

### Inherited from Number

### Inherited from java.io.Serializable

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ScalaNumericConversions to StringAdd

### Inherited by implicit conversion any2stringfmt from ScalaNumericConversions to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from ScalaNumericConversions to ArrowAssoc[ScalaNumericConversions]

### Inherited by implicit conversion any2Ensuring from ScalaNumericConversions to Ensuring[ScalaNumericConversions]

### Ungrouped